#! /usr/bin/env python3
# -*- coding: utf-8 -*-

import socket
import sys

# Constant declaration ---------------------------------------

# Allow to launch the codec as pseudo daemon thanks to socket
IS_ON = True
SOCKET_ADRESS = "/tmp/tst_socket"
END_OF_SERVICE_CMD = "END"
MAX_DATA_LENGTH = 4096
WANTED_FORMAT = 'json'
DEBUG_ON = True
# ------------------------------------------------------------

print("\n---------------------- Socket Client test ----------------------")
print("\nPlease enter payload that you want to send to the codec server.")

# The connection is done, client application can be running
while(IS_ON):

	# Connection to the server
	try:
		# Creation of the socket and bind the socket to the port
		CommSocket = socket.socket( socket.AF_UNIX, socket.SOCK_STREAM )
		CommSocket.connect(SOCKET_ADRESS)
	
	except socket.error as msg:
		print("Catched exception :", msg)
		sys.exit(1)

	payload = input(">> ")
	
	try:

		if( payload == "q" ):
			break
		
		elif( payload == END_OF_SERVICE_CMD ):
			# Send the payload to the decoding server
			CommSocket.sendall(payload.encode())
		
			break
		
		else:
			# Send the payload to the decoding server
			CommSocket.sendall(payload.encode())
		
			# Get the decoded data
			DecodeData = CommSocket.recv( MAX_DATA_LENGTH )
		
			# Print the decoded data
			print( "Decoded Data : \n", DecodeData )

	finally:
		print("Closing socket")
		CommSocket.shutdown(socket.SHUT_RDWR)
		CommSocket.close()

